cargo-sonar:
  stage: test
  interruptible: true
  needs:
    - audit
    - clippy
    - deny
    - outdated
    - tarpaulin
    - udeps
  artifacts:
    paths:
      - sonar-issues.json
      - sonar-coverage.xml
  script:
    - cargo run -- --issues audit,clippy,deny,outdated,udeps --coverage tarpaulin
  
sonar:
  stage: test
  image: docker.io/sonarsource/sonar-scanner-cli:latest
  needs:
    - cargo-sonar
  variables:
    SONAR_LOGIN: $SONAR_TOKEN
  rules:
    - if: '$SONAR_TOKEN != null'
  script:
    - git fetch --unshallow
    - sonar-scanner
     
